# Exercise Asymmetric TSP

# DATA
param N;
set Nodes := 0..N;
param c {Nodes,Nodes};

# VARIABLES
var x {Nodes,Nodes} binary;		# Arc variable

# OBJECTIVE
minimize z: sum {i in Nodes, j in Nodes} c[i,j]*x[i,j];

# CONSTRAINTS
# Degree constraints
subject to In_degree {j in Nodes}:
  sum {i in Nodes} x[i,j] = 1;
subject to Out_degree {i in Nodes}:
  sum {j in Nodes} x[i,j] = 1;

# S.E.C.
subject to Subtour_123:
  sum {i in {1,2,3}, j in {1,2,3}} x[i,j] <= 2;
subject to Subtour_045:
  sum {i in {0,4,5}, j in {0,4,5}} x[i,j] <= 2;
subject to Subtour_67:
  sum {i in {6,7}, j in {6,7}} x[i,j] <= 1;
subject to Subtour_1234:
  sum {i in {1,2,3,4}, j in {1,2,3,4}} x[i,j] <= 3;
subject to Subtour_0567:
  sum {i in {0,5,6,7}, j in {0,5,6,7}} x[i,j] <= 3;

###############
data;
param N := 7;

param c:	0		1		2		3		4		5		6		7 :=
0			999		6.4		5.1		3.5		3.3		1.3		2.5		3.3
1			4.7		999		3.7		2.1		5.1		6.0		7.2		9.0
2			4.2		4.5		999		1.6		3.2		5.5		6.7		8.5
3			2.6		2.9		1.6		999		3.0		3.9		5.1		6.9
4			3.3		4.1		3.2		1.2		999		4.6		5.8		7.6
5			3.9		7.4		4.9		4.5		3.3		999		1.2		3.0
6			3.5		7.0		5.7		4.1		2.9		1.2		999		2.3
7			6.0		8.5		8.2		6.6		5.4		3.0		2.3		999;

end;
