# Exercise Directed CPP

# DATA
param N;
set Nodes := 0..N;
param c {Nodes,Nodes};
param e {Nodes};

# VARIABLES
var x {Nodes,Nodes} >=0;	# Flow variables

# CONSTRAINTS
subject to Rebalance {i in Nodes}:
  sum {j in Nodes: j<>i} (x[j,i]-x[i,j]) = e[i];

# OBJECTIVE
minimize z: sum {i in Nodes, j in Nodes} c[i,j]*x[i,j];

###############
data;
param N := 5;

param c :	0	1	2	3	4	5 :=
0			999	 18	999	999	 26	999
1			999	999	 10	999	999	999
2			999	999	999	 37	999	999
3			999	999	999	999	 21	999
4			999	999	 43	999	999	 28
5			 23	999	999	999	 25	999;

param e :=
0	 1
1	 0
2	-1
3	 0
4	-1
5	 1;

end;
